function [ffn,endn] = PrepGenReg(q,k)
%-------------------------------------------------------------------------
% function [rejprob,Wald_tab] = RESET_Null(T,p,k,q,bb,kern,simnum,percvec,coeffvec)
%
% Function computes auxiliary values for the construction of the regressors
%
% Input:   k     ... number of I(1) regressors
%          q     ... highest order for RESET test
%
% Output: ffn, endn   ... Input for GenRESET_Regressors
%
%
% OS, 2013
%-------------------------------------------------------------------------


% Preparation of input for generation of regressors
endn = [];
ffn = [];
% Preperation part for the generation of the nonlinear regressors
if q > 2
    t = 0;
    endn = zeros(q,1);
    num = (q-2)*k;
    ffn = zeros(num,1);
    for r = 3:q
        endn(r) = nchoosek(r-1+k,k)-1-k; % different terms up to the (r-1)th power 
        for j = 1:k
            t = t + 1; 
            ffn(t) = nchoosek(r-1+k-j,r-1);
        end;
    end;
end;