function[Z_x] = Z_regressors(Sx);
%--------------------------------------------------------------------------
% function[Z_x] = Z_regressors(Sx);
%
% Function to generate auxiliary regressors for IM-OLS regression (2)
%
% Input:  Sx... Summed Regressors in R^{T \times dim(x)}
%
% Output: Z_x ... Modified regressors in R^{T \times dim(x)}
%
% TJV and MW, October 2009
%--------------------------------------------------------------------------

[T,dimx] = size(Sx);

% Inverse and reinverse double sum computation:
InvBase = Sx(end:-1:1,:);
Step2 = cumsum(InvBase,1);

% Reinvert again:
RevBase = Step2(end:-1:1,:);
Z_x = cumsum(RevBase,1);